using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GeoMapLib
{
    public partial class FormInputBox : Form
    {
        public string m_value;
        public string m_message;

        public FormInputBox(string message, string initValue)
        {
            InitializeComponent();
            m_value = initValue;
            m_message = message;
        }

        private void FormInputBox_Load(object sender, EventArgs e)
        {
            labelMessage.Text = m_message;
            textBoxInputData.Text = m_value;
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
            this.Close();
        }

        private void FormInputBox_FormClosing(object sender, FormClosingEventArgs e)
        {
            m_value = textBoxInputData.Text;
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }
}