using System;
using System.Collections.Generic;
using System.Text;


namespace GeoMapLib
{

    public static class Geometry
    {

        //***************************************************************************
        //                           @@@@萔
        //---------------------------------------------------------------------------
        public const double MAX_TERA = 1000000000000.0;
        public const double MIN_PICO = 1E-12;



         //***************************************************************************
        //                           @@@@֐
        //---------------------------------------------------------------------------

        //Q̐邩肷B
        public static bool lineSegmentsCross(stXY a1, stXY a2, stXY b1, stXY b2)
        {
            double s = 0;
            double t = 0;
            bool cross = false;
            stXY crossPoint = default(stXY);
            int nret = 0;

            nret = lineCrossPoint(a1, a2, b1, b2, ref s, ref t, ref crossPoint);
            if (nret == -1) return false;

            cross = s >= 0 & s <= 1 & t >= 0 & t <= 1;
            if (cross)
            {
                return true;
            }
            else
            {
                return false;

            }
        }

        // Q̐邩肷B[_m͏B
        public static bool lineSegmentsCrossInner(stXY a1, stXY a2, stXY b1, stXY b2)
        {
            double s = 0;
            double t = 0;
            bool cross = false;
            stXY crossPoint = default(stXY);
            int nret = 0;

            nret = lineCrossPoint(a1, a2, b1, b2, ref s, ref t, ref crossPoint);
            if (nret == -1) return false;

            cross = s >= 0 & s <= 1 & t >= 0 & t <= 1;
            if (( s == 0 && t == 0) || ( s==0 && t == 1 ) || 
                (s == 1 && t == 0 ) || (s == 1 && t == 1 ))  cross = false;

            return cross;
        }

        // Q̌_߂
        //
        // P: p = (p2 - p1) * s + p1 
        // Q: p = (p4 - p3) * t + p3 
        //
        // ߂l@1:
        //          -1 : s
        public static int lineCrossPoint(stXY p1, stXY p2, stXY p3, stXY p4, ref double s, ref double t, ref stXY crossPnt)
        {
            double y43 = 0;
            double y31 = 0;
            double y21 = 0;
            double x21 = 0;
            double x43 = 0;
            double x31 = 0;
            double det = 0;

            y43 = p4.y - p3.y;
            y31 = p3.y - p1.y;
            y21 = p2.y - p1.y;
            x43 = p4.x - p3.x;
            x31 = p3.x - p1.x;
            x21 = p2.x - p1.x;

            det = y43 * x21 - x43 * y21;
            if ((Math.Abs(det) < 1E-12))
            {
                return -1;
            }

            s = (y43 * x31 - x43 * y31) / det;
            t = (y21 * x31 - x21 * y31) / det;

            crossPnt.x = (p2.x - p1.x) * s + p1.x;
            crossPnt.y = (p2.y - p1.y) * s + p1.y;
            return 1;
        }


 
        //***************************************************************************
        //                           @@@|S֐
        //---------------------------------------------------------------------------

        //Q̑p`dȂ邩肷B
        //
        // bboxCheck : oEfBO{bNXł̔sȂꍇfalsewB

        public static bool polygonsOverlap(clsPoints poly1, clsPoints poly2, bool bboxCheck)
        {
            int i, j , n , m ;
            stXY a1 = default(stXY);
            stXY a2 = default(stXY);
            stXY b1 = default(stXY);
            stXY b2 = default(stXY);

            if (poly1.m_numPoints < 1 | poly2.m_numPoints < 1) return false;

            //bounding box`FbN
            if (bboxCheck)
            {
                if (poly2.m_maxX < poly1.m_minX | poly1.m_maxX < poly2.m_minX) return false;
                if (poly2.m_maxY < poly1.m_minY | poly1.m_maxY < poly2.m_minY) return false;
            }

            //ӂ̌`FbN
            n = poly1.m_numPoints - 2;
            for (i = 0; i <= n; i++)
            {
                m = poly2.m_numPoints - 2;
                a1 = poly1.m_point[i];
                a2 = poly1.m_point[i + 1];
                for (j = 0; j <= m; j++)
                {
                    b1 = poly2.m_point[j];
                    b2 = poly2.m_point[j + 1];

                    bool cross = lineSegmentsCross(a1, a2, b1, b2);
                    if (cross)
                    {
                        return true;
                    }
                }
            }

            //_̑p`Ɋ܂܂邩`FbN
            //poly1̒_
            n = poly1.m_numPoints - 2;
            for (i = 0; i <= n; i++)
            {
                if (pointIsInside(poly1.m_point[i],  poly2)) return true;
            }

            //poly2̒_
            n = poly2.m_numPoints - 2;
            for (i = 0; i <= n; i++)
            {
                if (pointIsInside(poly2.m_point[i],  poly1)) return true;
            }

            return false;
        }



        //_p`̒ɂ邩肷B
        //
        //XƑp`̌_ɂ锻B
        // QlF_̑p`ɑ΂O@http://www.hiramine.com/programming/graphics/2d_ispointinpolygon.html
        //
        public static bool pointIsInside(stXY point,  clsPoints polygon)
        {
            int i = 0;
            int n = 0;
            int numPoints = 0;
            stXY point0 = default(stXY);
            stXY point1 = default(stXY);
            bool p0IsRight = false;
            bool p0IsUpper = false;
            bool p1IsRight = false;
            bool p1IsUpper = false;
            bool cross = false;
            int numCross = 0;
            double x = 0;

            numPoints = polygon.m_numPoints;
            if (numPoints < 1) return false;

            point0 = polygon.m_point[0];
            p0IsRight = (point.x <= point0.x);
            p0IsUpper = (point.y <= point0.y);

            n = numPoints - 1;
            for (i = 1; i <= n; i++)
            {
                point1 = polygon.m_point[i];
                p1IsRight = (point.x <= point1.x);
                p1IsUpper = (point.y <= point1.y);

                if (p0IsUpper != p1IsUpper)
                {
                    // \
                    if (p0IsRight == p1IsRight)
                    {
                        //͓_̉Êǂ炩̑ɂ
                        if (p0IsRight)
                        {
                            //ォ牺ɉ؂鎞-1 t+1
                            if (p0IsUpper) numCross -= 1; else numCross += 1;
                        }
                    }
                    else
                    {
                        //_߂
                        x = point0.x + (point1.x - point0.x) * (point.y - point0.y) / (point1.y - point0.y);
                        if (point.x <= x)
                        {
                            if (p0IsUpper) numCross -= 1; else numCross += 1;
                        }
                    }
                }

                point0 = point1;
                p0IsRight = p1IsRight;
                p0IsUpper = p1IsUpper;
            }

            //_@OFO@OȊOF
            cross = (numCross != 0);
            return cross;
        }

        public static bool pointIsInside(double x, double y, clsPoints polygon)
        {
            stXY xy = new stXY();
            xy.x = x;
            xy.y = y;
            return pointIsInside(xy,  polygon);
        }

        // p`킩肷B
        //
        // ߂l@OF
        //           -1 : _R_ȉ
        //           -2 : ĂȂ
        //           -3 : Ȍ
        //
        public static int checkPolygon(clsPoints points)
        {
            try
            {
                stXY[] xy = points.points;
                int numPoints = points.numPoints;
                int numSegments = numPoints -1;

                if (numPoints < 4 ) return -1;

                double dx = xy[numPoints - 1].x - xy[0].x;
                double dy = xy[numPoints - 1].y - xy[0].y;
                if ((dx * dx + dy * dy) > 1e-20) return -2;

                stXY a1,a2,b1,b2;
                for (int i = 0; i < numSegments - 1; i++)
                {
                    a1 = xy[i];
                    a2 = xy[i + 1];
                    for (int j = i + 1; j < numSegments; j++)
                    {
                        b1 = xy[j];
                        b2 = xy[j + 1];

                        bool cross = lineSegmentsCrossInner(a1, a2, b1, b2);
                        if (cross) return -3;
                    }
                }

                return 0;

            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return -1;
            }
        }
    }

}
