using System;
using System.Collections.Generic;
using System.Text;

namespace GeoMapLib
{
    //***************************************************************************
    //                           @AtBϊ֐
    //---------------------------------------------------------------------------

    public class clsAffine
    {
        
        const int maxorder = 10;
        double a, b, c, d, e, f, g, h;
        bool coefCalculated = false;

        // AtBϊ̌W߂
        //
        // refPointsFrom[]  ϊ̎QƓ_iS_ȏj
        // refPointsTo[]    ϊ̎QƓ_iϊƓ_j
        //
        // ߂lOFI
        //         FG[
        //
        public int calcCoefficient(stXY[] refPointsFrom, stXY[] refPointsTo)
        {
            try
            {
                int numPoints = refPointsFrom.Length;
                if (numPoints != refPointsTo.Length) return -1;

                double[] x = new double[numPoints];
                double[] y = new double[numPoints];
                double[] XX = new double[numPoints];
                double[] YY = new double[numPoints];
                double[] coef = null;

                for (int i = 0; i < numPoints; i++)
                {
                    x[i] = refPointsFrom[i].x;
                    y[i] = refPointsFrom[i].y;
                    XX[i] = refPointsTo[i].x;
                    YY[i] = refPointsTo[i].y;
                }

                int nret = Aff2Coef(x, y, XX, YY, numPoints, out coef);
                if (nret < 0) return -2;
                a = coef[0];
                b = coef[1];
                c = coef[2];
                d = coef[3];
                e = coef[4];
                f = coef[5];
                g = coef[6];
                h = coef[7];
                coefCalculated = true;
                return 0;
            }
            catch (Exception ex)
            {
                return -100;
            }
        }

        // AtBϊs
        //
        // E̊֐ĂԑOɁAcalcCoefficient()ŕϊW߂ĂB
        //
        // ߂lOFI
        //         FG[
        //
        public int conv( ref stXY point )
        {
            if (!coefCalculated) return -1;
            double x = point.x;
            double y = point.y;

            point.x = a + b * x + c * y + d * x * y;
            point.y = e + f * x + g * y + h * x * y;

            return 0;
        }

        public int conv(ref double x, ref double y)
        {
            if (!coefCalculated) return -1;

           double newX = a + b * x + c * y + d * x * y;
           double newY = e + f * x + g * y + h * x * y;
           x = newX;
           y = newY;

            return 0;
        }

        public int conv(double x, double y, out double newX, out double newY)
        {
            newX = 0;
            newY = 0;
            if (!coefCalculated) return -1;

            newX = a + b * x + c * y + d * x * y;
            newY = e + f * x + g * y + h * x * y;

            return 0;
        }

        public int conv(stXY point, out stXY newPoint)
        {
            newPoint.x = 0;
            newPoint.y = 0;
            if (!coefCalculated) return -1;
            double x = point.x;
            double y = point.y;

            newPoint.x = a + b * x + c * y + d * x * y;
            newPoint.y = e + f * x + g * y + h * x * y;

            return 0;
        }

        public int conv(stXY[] points, out stXY[] newPoints)
        {
            newPoints = null;
            try
            {
                if (!coefCalculated) return -1;
                int numPoints = points.Length;
                newPoints = new stXY[numPoints];

                for (int i = 0; i < numPoints; i++)
                {
                    double x = points[i].x;
                    double y = points[i].y;

                    newPoints[i].x = a + b * x + c * y + d * x * y;
                    newPoints[i].y = e + f * x + g * y + h * x * y;
                }

                return 0;
            }
            catch (Exception ex)
            {
                return -100;
            }
        }

        public int conv(ref stXY[] points)
        {
            try
            {
                if (!coefCalculated) return -1;
                int numPoints = points.Length;

                for (int i = 0; i < numPoints; i++)
                {
                    double x = points[i].x;
                    double y = points[i].y;

                    double newX = a + b * x + c * y + d * x * y;
                    double newY = e + f * x + g * y + h * x * y;

                    points[i].x = newX;
                    points[i].y = newY;
                }

                return 0;
            }
            catch (Exception ex)
            {
                return -100;
            }
        }

        const double MinReal = 1e-6;

        // Aꎟ̉߂ iKEXEW_̏@j
        //< DGJR > : Double Gauss Jordan Reduction

        //  a : n X n+m ɐlĂ}gbNX   a[ii][jj]
        //  msim{lj̔zA߂̂m͕̌WA
        //  ̂l͉Eӂ\B̂l͕̉ԂB
        //  ii,jj : ii s@@jj @̔z   a ̔z̑傫
        //  m : ̑g
        //  n : m̐       npm=n+m
        //  det : s񎮂̒l
        //  return 0 :     1 : ts񂪋܂Ȃ
        //  	DGJR(&a,3,4,3,4,&det);
        int DGJR(double[][] a, int ii, int jj, int n, int npm, out double det)
        {
            int i, j, k, mx, kp1;
            double cmx, rmx, aik, amx;

            det = 1;
            for (k = 0; k < n; k++)
            {
                cmx = 0;
                mx = 0;
                for (i = k; i < n; i++)
                {
                    rmx = 0;
                    for (j = k; j < n; j++)
                    {
                        rmx = Math.Max(rmx, Math.Abs(a[j][i]));
                    }
                    if (rmx < MinReal) return -1;
                    aik = Math.Abs(a[k][i]) / rmx;
                    if (cmx < aik)
                    {
                        cmx = aik;
                        mx = i;
                    }
                }
                if (k != mx)
                {
                    det = -(det);
                    for (j = k; j < npm; j++)
                    {
                        amx = a[j][mx];
                        a[j][mx] = a[j][k];
                        a[j][k] = amx;
                    }
                }
                det = det * a[k][k];
                kp1 = k + 1;
                for (j = kp1; j < npm; j++)
                    a[j][k] = a[j][k] / a[k][k];
                for (i = 0; i < n; i++)
                {
                    if (i != k)
                    {
                        for (j = kp1; j < npm; j++)
                            a[j][i] = a[j][i] - a[k][i] * a[j][k];
                    }
                }
            }
            return 0;
        }


        //AtBϊ(۽т܂)̌W߂ iŏQ@j
        //  X=a+bx+cy+dxy       X,Y : ƂȂWn̍W   XX,YY
        //  Y=e+fx+gy+hxy       x,y : ϊׂWn     x,y
        //        no : _ >= 4
        //		coef[8] : a,b,c,d,e,f,g,h ̏ŕԂ
        //  return=0 : ,   =1 : ts񂪋܂Ȃ,  =2 : _Ȃ
        int Aff2Coef(double[] x, double[] y, double[] XX, double[] YY,
                            int no, out double[] coef)
        {
            double[][] a = new double[maxorder][];
            double det;
            int n, flag, i, j;
            coef = new double[8];

            for (i = 0; i < maxorder; i++) a[i] = new double[maxorder];

            if (no < 4) return -2;
            for (i = 0; i < maxorder; i++)
            {
                for (j = 0; j < maxorder; j++)
                    a[i][j] = 0;
            }
            for (n = 0; n < no; n++)
            {
                a[0][0] += 1.0;
                a[0][1] += x[n];
                a[0][2] += y[n];
                a[0][3] += x[n] * y[n];
                a[4][0] += XX[n];
                a[5][0] += YY[n];
                a[1][1] += x[n] * x[n];
                a[1][2] += x[n] * y[n];
                a[1][3] += x[n] * x[n] * y[n];
                a[4][1] += x[n] * XX[n];
                a[5][1] += x[n] * YY[n];
                a[2][2] += y[n] * y[n];
                a[2][3] += x[n] * y[n] * y[n];
                a[4][2] += y[n] * XX[n];
                a[5][2] += y[n] * YY[n];
                a[3][3] += x[n] * x[n] * y[n] * y[n];
                a[4][3] += x[n] * y[n] * XX[n];
                a[5][3] += x[n] * y[n] * YY[n];
            }
            a[1][0] = a[0][1];
            a[2][0] = a[0][2];
            a[2][1] = a[1][2];
            a[3][0] = a[0][3];
            a[3][1] = a[1][3];
            a[3][2] = a[2][3];

            flag = DGJR(a, maxorder, maxorder, 4, 6, out det);
            if (flag == 1) return flag;
            coef[0] = a[4][0];
            coef[1] = a[4][1];
            coef[2] = a[4][2];
            coef[3] = a[4][3];
            coef[4] = a[5][0];
            coef[5] = a[5][1];
            coef[6] = a[5][2];
            coef[7] = a[5][3];
            return flag;
        }


        //AtBϊi۽т܂ށǰW߁AZsc߂
        //  X=a+bx+cy+dxy	X,Y : ƂȂWn̍W   XX,YY
        //  Y=e+fx+gy+hxy	x,y : ϊׂWn     x,y
        //        no : _ >= 4
        //	xn,yn : ϊ̍W
        //	rx,ry : e_̎c
        //	rstd : c̕W΍
        int Aff2Trans(int no, double[] x, double[] y, double[] XX, double[] YY,
                   double[] xn, double[] yn, double[] rx, double[] ry,
                       out double rxstd, out double rystd)
        {
            double[] coef = new double[10];
            double dxm, dym, tdx, tdy, dxs, dys;
            int n, flag;
            rxstd = 0;
            rystd = 0;
            if (no < 4) return -1;
            flag = Aff2Coef(x, y, XX, YY, no, out coef);
            if (flag != 0) return flag;

            tdx = 0; tdy = 0;
            for (n = 0; n < no; n++)
            {
                xn[n] = coef[0] + coef[1] * x[n] + coef[2] * y[n] + coef[3] * x[n] * y[n];
                yn[n] = coef[4] + coef[5] * x[n] + coef[6] * y[n] + coef[7] * x[n] * y[n];
                rx[n] = xn[n] - XX[n];
                ry[n] = yn[n] - YY[n];
                tdx += rx[n];
                tdy += ry[n];
            }
            dxm = tdx / no;
            dym = tdy / no;

            dxs = 0;
            dys = 0;
            for (n = 0; n < no; n++)
            {
                dxs += (rx[n] - dxm) * (rx[n] - dxm);
                dys += (ry[n] - dym) * (ry[n] - dym);
            }
            rxstd = Math.Sqrt(dxs / no);
            rystd = Math.Sqrt(dys / no);
            return flag;

        }
    }

}
