using System;
using System.Collections.Generic;
using System.Text;
using GeoMapLib;

namespace GpsLib
{
    //***************************************************************************
    //                          @GPSM@\NX
    //---------------------------------------------------------------------------

    class clsGps
    {

        // 񋓑
        enum gpsTypes { NMEA, UBLOX, SIRF };

        // ^
        public delegate int eventHandler(stEvent eventType);

        public struct stEvent
        {
            public bool timeout;
            public bool timeUpdated;
            public bool dataReceived;
            public bool positionUpdated;
            public bool velecityUpdated;
            public bool heightUpdated;
            public bool directionUpdated;
            public bool dopUpdated;
            public bool numOfSatUpdated;
            public bool satDataUpdated;

        }
        
        // ϐ
        public int m_gpsType;                       // GPS̋@
        public clsRs232c m_rs232c;                  // RS232C
        public event eventHandler onGpsEvent;         // f[^MɌĂяo[ŨR[obN֐
        bool m_stop;                                // M𒆎~ꍇTRUE

        public string m_recvTextData = "";               // MeLXgf[^


        // 
        public clsGps(int gpsType)
        {
            m_gpsType = gpsType;
        }

        public void setEventReportFunc(eventHandler func)
        {
            if (func == null) onGpsEvent = null;
            else onGpsEvent += func;
        }



        //***********************************************
        //                   ʐM
        //***********************************************

        // GPSM@RS232CŐڑB
        //
        // peBAPXgbvrbgAWf[^rbg
        //
        // ߂l@OFI
        //         FG[
        //
        public int open(string portName, int baudrate)
        {
            int nret;

            try
            {
                m_rs232c = new clsRs232c();
                if (m_rs232c == null) return -1;

                nret = m_rs232c.open(portName, baudrate, 0, 8, 1);
                if (nret < 0) return -2;

                return 0;
            }
            catch (Exception ex)
            {
                MsgBox(ex.Message);
                return -4;
            }
        }

        // ڑؒfB
        //
        public void close()
        {
            if (m_rs232c == null) return;
            m_rs232c.close();
            m_rs232c = null;
        }

        //***********************************************
        //                   M
        //***********************************************

        // MJnB
        //
        public int start()
        {
            int nret;

            m_stop = false;
            while (! m_stop)
            {
                string line = readLine();
                if (! string.IsNullOrEmpty(line))
                {
                    stEvent ev = new stEvent();
                    ev.timeout = false;
                    ev.positionUpdated = false;
                    ev.velecityUpdated = false;
                    ev.heightUpdated = false;
                    ev.directionUpdated = false;
                    ev.dopUpdated = false;
                    ev.numOfSatUpdated = false;
                    ev.satDataUpdated = false;
                    ev.dataReceived = true;
                    ev.timeUpdated = false;
                    nret = onGpsEvent(ev);
                }
            }
            return 0;
        }

        // M𒆎~B
        //
        public void stop()
        {
            m_stop = true;
        }

        public string readLine()
        {
            return m_rs232c.readLine();
        }

        //***********************************************
        //                   ̑
        //***********************************************

        void MsgBox(string message)
        {
            Util.MsgBox(message);
        }



    }
}
