using System;
using System.Collections.Generic;
using System.Text;

namespace GeoMapLib
{



    //***************************************************************************
    //                           @@@@_NX
    //---------------------------------------------------------------------------

    //Ȑ|S̓_\NX

    [Serializable()]
    public class clsPoints
    {
        public const double MAX_TERA = 1000000000000.0;
        public const double MIN_PICO = 1E-12;
        public const int NUM_SEGMENT_POINTS = 100;

        public int m_numPoints;
        public stXY[] m_point = new stXY[0];
        public double m_minX;
        public double m_minY;
        public double m_maxX;
        public double m_maxY;
        public double m_centerX;
        public double m_centerY;
        public struct stMinMax
        {
            public double xMin;
            public double yMin;
            public double xMax;
            public double yMax;

            public stMinMax(double xMin, double yMin, double xMax, double yMax)
            {
                this.xMin = xMin;
                this.xMax = xMax;
                this.yMin = yMin;
                this.yMax = yMax;
            }

            public bool contains(double x, double y)
            {
                return (xMin <= x && x <= xMax && yMin <= y && y <= yMax);
            }
         }

        public stMinMax[] m_segmentMinMax;  // C100_̃ZOgMin,Max
        public int m_numSegments;           //   @@@@@@@@ZOg

        public clsPoints()
        {
            setNumPoints(0);
        }

        public  clsPoints(int numPoints)
        {
            setNumPoints(numPoints);
        }

        public clsPoints(double lat, double lon)
        {
            setNumPoints(1);
            storePoint(0, lon, lat);
            calcCenterMinMax();
        }

        public int numPoints
        {
            get { return m_numPoints; }
        }

        public stXY[] points
        {
            get { return m_point; }
        }

        public double minX
        {
            get { return m_minX; }
        }

        public double minY
        {
            get { return m_minY; }
        }

        public double maxX
        {
            get { return m_maxX; }
        }

        public double maxY
        {
            get { return m_maxY; }
        }

        public double centerX
        {
            get { return m_centerX; }
        }

        public double centerY
        {
            get { return m_centerY; }
        }


        //w肵_̃mۂB
        public virtual int setNumPoints(int numPoints)
        {
            try
            {
                if (numPoints < 0) numPoints = 0;

                Array.Resize(ref m_point, numPoints);
                m_numPoints = numPoints;
            }
            catch (Exception)
            {
                return -1;
            }

            return 0;
        }
        
        // _ύXB
        public virtual int resize(int numPoints)
        {
            try
            {
                Array.Resize(ref m_point, numPoints);
                m_numPoints = numPoints;
                return numPoints;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return -1;
            }
        }

        //_i[B
        //
        //̊֐ĂяoOsetNumPoints()ŃmۂĂ˂΂ȂȂB
        //
        public virtual int storePoint(int index, double x, double y)
        {
            if (index < 0 | index > m_numPoints - 1) return -1;
            m_point[index].x = x;
            m_point[index].y = y;
            return 0;
        }

        //_ǉB
        //
        public virtual int addPoint( double x, double y)
        {
            try
            {
                m_numPoints++;
                resize(m_numPoints);
                m_point[m_numPoints - 1].x = x;
                m_point[m_numPoints - 1].y = y;
                return m_numPoints;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return -1;
            }
        }

        //_ǉBz̑傫͎Őݒ肷B
        //@Lȃf[^͕KnumPointsŎ擾B
        //
        public virtual int addPoint2(double x, double y)
        {
            try
            {
                if (m_point.Length >= m_numPoints)
                {
                    Array.Resize(ref m_point, m_numPoints + 1000);
                }
                m_point[m_numPoints].x = x;
                m_point[m_numPoints].y = y;
                m_numPoints++;
                return m_numPoints;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return -1;
            }
        }

        //_wʒuɒǉB
        //
        //@index͐V_ł̒l
        //@V_ŏɂꍇAindex0wAŌ̓_̏ꍇA}OnumPoints
        public virtual int insertPoint(int index, double x, double y)
        {
            try
            {
                if (index < 0 || index > m_numPoints) return -1;

                int i = 0;
                int j = 0;

                stXY[] newPoint = new stXY[m_numPoints + 1];
                j = 0;
                for (i = 0; i <= m_numPoints; i++)
                {
                    if (i == index)
                    {
                        newPoint[i].x = x;
                        newPoint[i].y = y;
                        continue;
                    }
                    newPoint[i] = m_point[j];
                    j += 1;
                }
                m_numPoints += 1;
                m_point = newPoint;
                calcCenterMinMax();

                return 0;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return -1;
            }
        }

        //Ciŏ̓_C̍ŌɃRs[j
        //
        public virtual int closeLine()
        {
            return addPoint(m_point[0].x, m_point[0].y);
        }

        //_폜B
        public virtual int removePoint(int index)
        {
            try
            {
                if (index < 0 || index > m_numPoints - 1) return -1;

                int i = 0;

                if (m_numPoints == 1)
                {
                    m_numPoints = 0;
                    Array.Resize(ref m_point, 0);

                    m_minX = 0;
                    m_minY = 0;
                    m_maxX = 0;
                    m_maxY = 0;
                    m_centerX = 0;
                    m_centerY = 0;
                    return 0;
                }

                for (i = index; i < m_numPoints - 1; i++)
                {
                    m_point[i] = m_point[i + 1];
                }
                m_numPoints--;
                Array.Resize(ref m_point, m_numPoints);
                calcCenterMinMax();

                return 0;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return -1;
            }

        }


        //SMinMaxvZAݒ肷B
        public object calcCenterMinMax()
        {
            int i = 0;
            int n = 0;
            double x = 0;
            double y = 0;
            double totalX = 0;
            double totalY = 0;
            if (m_numPoints == 0) return 0;

            try
            {
                totalX = 0;
                totalY = 0;
                m_minX = MAX_TERA;
                m_minY = MAX_TERA;
                m_maxX = -MAX_TERA;
                m_maxY = -MAX_TERA;
                n = m_numPoints - 1;
                for (i = 0; i <= n; i++)
                {
                    x = m_point[i].x;
                    y = m_point[i].y;

                    totalX += x;
                    totalY += y;

                    if (x < m_minX) m_minX = x;
                    if (y < m_minY) m_minY = y;
                    if (x > m_maxX) m_maxX = x;
                    if (y > m_maxY) m_maxY = y;
                }

                m_centerX = totalX / m_numPoints;
                m_centerY = totalY / m_numPoints;

                return 0;
            }
            catch (Exception ex)
            {
                MsgBox(ex.ToString());
                return -1;

            }
        }

        //NXϐݒ肷
        public virtual int loadPoints(clsPoints source)
        {
            if (source == null) return -1;

            m_numPoints = source.numPoints;
            m_point = source.m_point;
            m_minX = source.m_minX;
            m_minY = source.m_minY;
            m_maxX = source.m_maxX;
            m_maxY = source.m_maxY;
            m_centerX = source.m_centerX;
            m_centerY = source.m_centerY;
            return 0;
        }

        //Clone擾B
        public clsPoints getClone()
        {
            try
            {
                clsPoints points = new clsPoints();
                int i = 0;

                points.setNumPoints(m_numPoints);
                for (i = 0; i <= m_numPoints - 1; i++)
                {
                    points.m_point[i] = m_point[i];
                    points.calcCenterMinMax();
                }
                return points;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return null;
            }

        }

        // C̒Ԃ
        public double getLength()
        {
            try
            {
                if (m_numPoints < 2) return 0;
                double x0 = m_point[0].x;
                double y0 = m_point[0].y;
                double length = 0;
                for (int i = 1; i < m_numPoints; i++)
                {
                    double x1 = m_point[i].x;
                    double y1 = m_point[i].y;
                    double dx = x1 - x0;
                    double dy = y1 - y0;
                    length += dx * dx + dy * dy;
                    x0 = x1;
                    y0 = y1;
                }
                length = Math.Sqrt(length);

                return length;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return 0;
            }
        }

        // C̒̍WƐڐ߂
        public int getPathCenter(out double centerX, out double centerY, out double radAngle)
        {
            centerX = 0.0;
            centerY = 0.0;
            radAngle = 0.0;
            try
            {
                if (m_numPoints < 2) return 0;

                double length = getLength();
                double length2 = (length * length) / 2;

                double x0 = m_point[0].x;
                double y0 = m_point[0].y;
                length = 0;
                double x1 = 0, y1 = 0, dxy = 0;
                for (int i = 1; i < m_numPoints; i++)
                {
                    x1 = m_point[i].x;
                    y1 = m_point[i].y;
                    double dx = x1 - x0;
                    double dy = y1 - y0;
                    dxy = dx * dx + dy * dy;
                    if (length + dxy > length2) break;
                    length += dxy;
                    x0 = x1;
                    y0 = y1;
                }
                double deltaLength = Math.Sqrt(length2) - Math.Sqrt(length);
                double m = deltaLength / Math.Sqrt(dxy);

                centerX = m * (x1 - x0) + x0;
                centerY = m * (y1 - y0) + y0;
                radAngle = Math.Atan2(centerY - y0, centerX - x0);

                return 0;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return -1;
            }
        }

        // C100_̃ZOgMin,Max߂
        public int getSegmentMinMax()
        {
            try
            {
                int numSegments = (int) Math.Ceiling((double)m_numPoints / NUM_SEGMENT_POINTS);
                m_segmentMinMax = new stMinMax[numSegments];
                for (int i = 0; i < numSegments; i++)
                {
                    m_segmentMinMax[i] = getMinMax(i * NUM_SEGMENT_POINTS, NUM_SEGMENT_POINTS);
                }
                m_numSegments = numSegments;
                return numSegments;
            }
            catch (Exception ex)
            {
                MsgBox(ex.ToString());
                return -100;
            }
        }

        // m_pointf[^̎w肵_̊Ԃ̍őŏ߂
        public stMinMax getMinMax(int startIndex, int numPoints)
        {
            try
            {
                double minX = double.MaxValue;
                double minY = double.MaxValue;
                double maxX = -double.MaxValue;
                double maxY = -double.MaxValue;
                int index = startIndex;
                for (int i = 0; i < numPoints; i++)
                {
                    if (index == m_numPoints) break;
                    double x = m_point[index].x;
                    double y = m_point[index].y;

                    if (x < minX) minX = x;
                    if (y < minY) minY = y;
                    if (x > maxX) maxX = x;
                    if (y > maxY) maxY = y;

                    index++;
                }
                return new stMinMax(minX, minY, maxX, maxY);
            }
            catch (Exception ex)
            {
                MsgBox(ex.ToString());
                return new stMinMax(m_minX, m_minY, m_maxX, m_maxY);
            }
        }

        // w肵_ɋ߂C̓_̃CfbNXԂ
        //
        // EZOg̍őŏf[^gpčĂB
        //   ̊֐gpOɁAgetSegmentMinMax()s邱ƁB
        //
        //  ߂ldistanceȓ̍ŏ̓_CfbNX
        //          -1 : Ȃ
        //          -2ȉFG[
        public int getClosestPointIndex(double x, double y, double distance)
        {
            try
            {
                if (m_numSegments < 1) getSegmentMinMax();
                double distance2 = double.MaxValue;
                int minIndex = -1;
                for (int i = 0; i < m_numSegments; i++)
                {
                    stMinMax minmax = m_segmentMinMax[i];
                    if (x > minmax.xMax + distance) continue;
                    if (y > minmax.yMax + distance) continue;
                    if (x < minmax.xMin - distance) continue;
                    if (y < minmax.yMin - distance) continue;

                    int index = i * NUM_SEGMENT_POINTS;
                    for (int j = 0; j < NUM_SEGMENT_POINTS; j++)
                    {
                        stXY point = m_point[index];
                        if (x > point.x + distance) continue;
                        if (y > point.y + distance) continue;
                        if (x < point.x - distance) continue;
                        if (y < point.y - distance) continue;

                        double xdis = x - point.x;
                        double ydis = y - point.y;
                        double dis2 = xdis * xdis + ydis * ydis;
                        if (dis2 < distance2)
                        {
                            distance2 = dis2;
                            minIndex = index;
                        }
                        index++;
                        if (index == m_numPoints) break;
                    }
                }
                if (Math.Sqrt(distance2) <= distance) return minIndex;
                return -1;
            }
            catch (Exception ex)
            {
                Util.MsgBox(ex.ToString());
                return -100;
            }
        }

        void MsgBox(string message)
        {
            Util.MsgBox(message);
        }

    }


}

